## qxmpp 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.3)
project(qxmpp)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 3)
set(VERSION_PATCH 2)
set(SO_VERSION 3)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
mark_as_advanced(VERSION_MAJOR VERSION_MINOR VERSION_PATCH VERSION_STRING)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/modules")

find_package(Qt5 5.7.0 REQUIRED COMPONENTS Core Network Xml)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

include(GNUInstallDirs)

option(BUILD_TESTS "Build tests." ON)
option(BUILD_INTERNAL_TESTS "Build internal tests." OFF)
option(BUILD_DOCUMENTATION "Build API documentation." OFF)
option(BUILD_EXAMPLES "Build examples." ON)

option(WITH_GSTREAMER "Build with GStreamer support for Jingle" OFF)

add_subdirectory(src)

if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(tests)
endif()

if(BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

include(CMakePackageConfigHelpers)

configure_package_config_file(
    QXmppConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfig.cmake
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/qxmpp"
)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfigVersion.cmake
    VERSION ${VERSION_STRING}
    COMPATIBILITY SameMajorVersion
)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfig.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfigVersion.cmake
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/qxmpp"
    COMPONENT Devel
)

# Generate qxmpp.pc
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/qxmpp.pc.in ${CMAKE_CURRENT_BINARY_DIR}/qxmpp.pc @ONLY)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/qxmpp.pc
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
    COMPONENT Devel
)

=== src/CMakeLists.txt ===
option(BUILD_SHARED "Build SHARED library" ON)

add_definitions(-DQXMPP_BUILD)

# disable Q_FOREACH()
add_definitions(-DQT_NO_FOREACH)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/base)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/client)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/server)

# Configure QXmppGlobal.h.in
if(BUILD_SHARED)
    set(QXMPP_BUILD_SHARED true)
else()
    set(QXMPP_BUILD_SHARED false)
endif()
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/base/QXmppGlobal.h.in ${CMAKE_CURRENT_BINARY_DIR}/base/QXmppGlobal.h @ONLY)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/base)

set(INSTALL_HEADER_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/base/QXmppGlobal.h

    # Base
    base/QXmppArchiveIq.h
    base/QXmppBindIq.h
    base/QXmppBitsOfBinaryContentId.h
    base/QXmppBitsOfBinaryData.h
    base/QXmppBitsOfBinaryDataList.h
    base/QXmppBitsOfBinaryIq.h
    base/QXmppBookmarkSet.h
    base/QXmppByteStreamIq.h
    base/QXmppDataForm.h
    base/QXmppDiscoveryIq.h
    base/QXmppElement.h
    base/QXmppEntityTimeIq.h
    base/QXmppHttpUploadIq.h
    base/QXmppIbbIq.h
    base/QXmppIq.h
    base/QXmppJingleIq.h
    base/QXmppLogger.h
    base/QXmppMamIq.h
    base/QXmppMessage.h
    base/QXmppMixIq.h
    base/QXmppMixItem.h
    base/QXmppMucIq.h
    base/QXmppNonSASLAuth.h
    base/QXmppPingIq.h
    base/QXmppPresence.h
    base/QXmppPubSubIq.h
    base/QXmppPubSubItem.h
    base/QXmppPushEnableIq.h
    base/QXmppRegisterIq.h
    base/QXmppResultSet.h
    base/QXmppRosterIq.h
    base/QXmppRpcIq.h
    base/QXmppSessionIq.h
    base/QXmppSocks.h
    base/QXmppStanza.h
    base/QXmppStartTlsPacket.h
    base/QXmppStream.h
    base/QXmppStreamFeatures.h
    base/QXmppStun.h
    base/QXmppUtils.h
    base/QXmppVCardIq.h
    base/QXmppVersionIq.h

    # Client
    client/QXmppArchiveManager.h
    client/QXmppBookmarkManager.h
    client/QXmppCarbonManager.h
    client/QXmppClient.h
    client/QXmppClientExtension.h
    client/QXmppConfiguration.h
    client/QXmppDiscoveryManager.h
    client/QXmppEntityTimeManager.h
    client/QXmppInvokable.h
    client/QXmppMamManager.h
    client/QXmppMessageReceiptManager.h
    client/QXmppMucManager.h
    client/QXmppOutgoingClient.h
    client/QXmppRegistrationManager.h
    client/QXmppRemoteMethod.h
    client/QXmppRosterManager.h
    client/QXmppRpcManager.h
    client/QXmppTransferManager.h
    client/QXmppTransferManager_p.h
    client/QXmppUploadRequestManager.h
    client/QXmppVCardManager.h
    client/QXmppVersionManager.h

    # Server
    server/QXmppDialback.h
    server/QXmppIncomingClient.h
    server/QXmppIncomingServer.h
    server/QXmppOutgoingServer.h
    server/QXmppPasswordChecker.h
    server/QXmppServer.h
    server/QXmppServerExtension.h
    server/QXmppServerPlugin.h
)

set(SOURCE_FILES
    # Base
    base/QXmppArchiveIq.cpp
    base/QXmppBindIq.cpp
    base/QXmppBitsOfBinaryContentId.cpp
    base/QXmppBitsOfBinaryData.cpp
    base/QXmppBitsOfBinaryDataList.cpp
    base/QXmppBitsOfBinaryIq.cpp
    base/QXmppBookmarkSet.cpp
    base/QXmppByteStreamIq.cpp
    base/QXmppConstants.cpp
    base/QXmppDataForm.cpp
    base/QXmppDiscoveryIq.cpp
    base/QXmppElement.cpp
    base/QXmppEntityTimeIq.cpp
    base/QXmppHttpUploadIq.cpp
    base/QXmppIbbIq.cpp
    base/QXmppIq.cpp
    base/QXmppJingleIq.cpp
    base/QXmppLogger.cpp
    base/QXmppMamIq.cpp
    base/QXmppMessage.cpp
    base/QXmppMixIq.cpp
    base/QXmppMixItem.cpp
    base/QXmppMucIq.cpp
    base/QXmppNonSASLAuth.cpp
    base/QXmppPingIq.cpp
    base/QXmppPresence.cpp
    base/QXmppPubSubIq.cpp
    base/QXmppPubSubItem.cpp
    base/QXmppPushEnableIq.cpp
    base/QXmppRegisterIq.cpp
    base/QXmppResultSet.cpp
    base/QXmppRosterIq.cpp
    base/QXmppRpcIq.cpp
    base/QXmppSasl.cpp
    base/QXmppSessionIq.cpp
    base/QXmppSocks.cpp
    base/QXmppStanza.cpp
    base/QXmppStartTlsPacket.cpp
    base/QXmppStream.cpp
    base/QXmppStreamFeatures.cpp
    base/QXmppStreamInitiationIq.cpp
    base/QXmppStreamManagement.cpp
    base/QXmppStun.cpp
    base/QXmppUtils.cpp
    base/QXmppVCardIq.cpp
    base/QXmppVersionIq.cpp

    # Client
    client/QXmppDiscoveryManager.cpp
    client/QXmppArchiveManager.cpp
    client/QXmppBookmarkManager.cpp
    client/QXmppCarbonManager.cpp
    client/QXmppClient.cpp
    client/QXmppClientExtension.cpp
    client/QXmppConfiguration.cpp
    client/QXmppEntityTimeManager.cpp
    client/QXmppInternalClientExtension.cpp
    client/QXmppInvokable.cpp
    client/QXmppMamManager.cpp
    client/QXmppMessageReceiptManager.cpp
    client/QXmppMucManager.cpp
    client/QXmppOutgoingClient.cpp
    client/QXmppRosterManager.cpp
    client/QXmppRegistrationManager.cpp
    client/QXmppRemoteMethod.cpp
    client/QXmppRpcManager.cpp
    client/QXmppTlsManager.cpp
    client/QXmppTransferManager.cpp
    client/QXmppUploadRequestManager.cpp
    client/QXmppVCardManager.cpp
    client/QXmppVersionManager.cpp

    # Server
    server/QXmppDialback.cpp
    server/QXmppIncomingClient.cpp
    server/QXmppIncomingServer.cpp
    server/QXmppOutgoingServer.cpp
    server/QXmppPasswordChecker.cpp
    server/QXmppServer.cpp
    server/QXmppServerExtension.cpp
    server/QXmppServerPlugin.cpp
)

if(WITH_GSTREAMER)
    find_package(GStreamer REQUIRED)
    find_package(GLIB2 REQUIRED)
    find_package(GObject REQUIRED)

    set(INSTALL_HEADER_FILES
        ${INSTALL_HEADER_FILES}
        client/QXmppCall.h
        client/QXmppCallManager.h
        client/QXmppCallStream.h
    )

    set(SOURCE_FILES
        ${SOURCE_FILES}
        client/QXmppCall.cpp
        client/QXmppCallManager.cpp
        client/QXmppCallStream.cpp
    )
endif()

if(BUILD_SHARED)
    add_library(qxmpp SHARED ${SOURCE_FILES})
else()
    add_library(qxmpp STATIC ${SOURCE_FILES})
endif()

set_target_properties(qxmpp PROPERTIES
    VERSION ${VERSION_STRING}
    SOVERSION ${SO_VERSION}
    EXPORT_NAME QXmpp
)

target_include_directories(qxmpp
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/base>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/client>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/server>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/base>
    $<INSTALL_INTERFACE:include/qxmpp>
    ${GLIB2_INCLUDE_DIR}
    ${GOBJECT_INCLUDE_DIR}
    ${GSTREAMER_INCLUDE_DIRS}
)

target_link_libraries(qxmpp
    PUBLIC
    Qt5::Core
    Qt5::Network
    Qt5::Xml
)

if(WITH_GSTREAMER)
    target_link_libraries(qxmpp
        PUBLIC
        ${GLIB2_LIBRARIES}
        ${GOBJECT_LIBRARIES}
        ${GSTREAMER_LIBRARY}
    )
endif()

install(
    TARGETS qxmpp
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT QXmppTarget
)

install(
    EXPORT QXmppTarget
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/qxmpp"
    FILE QXmpp.cmake
    NAMESPACE QXmpp::
    COMPONENT Devel
)

export(
    TARGETS qxmpp
    FILE QXmpp.cmake
)

install(
    FILES ${INSTALL_HEADER_FILES}
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/qxmpp"
)

=== tests/CMakeLists.txt ===
include_directories(.)

find_package(Qt5 REQUIRED COMPONENTS Test)

macro(add_simple_test TEST_NAME)
    add_executable(tst_${TEST_NAME} ${TEST_NAME}/tst_${TEST_NAME}.cpp)
    add_test(tst_${TEST_NAME} tst_${TEST_NAME})
    target_link_libraries(tst_${TEST_NAME} Qt5::Test qxmpp)
endmacro()

include_directories(${PROJECT_SOURCE_DIR}/src/base)
include_directories(${PROJECT_SOURCE_DIR}/src/client)
include_directories(${PROJECT_SOURCE_DIR}/src/server)
include_directories(${PROJECT_BINARY_DIR}/src/base)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_simple_test(qxmpparchiveiq)
add_simple_test(qxmppbindiq)
add_simple_test(qxmppbitsofbinarycontentid)
add_simple_test(qxmppbitsofbinaryiq)
add_simple_test(qxmppcarbonmanager)
add_simple_test(qxmppclient)
add_simple_test(qxmppdataform)
add_simple_test(qxmppdiscoveryiq)
add_simple_test(qxmppentitytimeiq)
add_simple_test(qxmpphttpuploadiq)
add_simple_test(qxmppiceconnection)
add_simple_test(qxmppiq)
add_simple_test(qxmppjingleiq)
add_simple_test(qxmppmammanager)
add_simple_test(qxmppmixitem)
add_simple_test(qxmppmessage)
add_simple_test(qxmppmessagereceiptmanager)
add_simple_test(qxmppmixiq)
add_simple_test(qxmppnonsaslauthiq)
add_simple_test(qxmpppushenableiq)
add_simple_test(qxmpppresence)
add_simple_test(qxmpppubsubiq)
add_simple_test(qxmppregisteriq)
add_simple_test(qxmppregistrationmanager)
add_simple_test(qxmppresultset)
add_simple_test(qxmpprosteriq)
add_simple_test(qxmpprostermanager)
add_simple_test(qxmpprpciq)
add_simple_test(qxmppserver)
add_simple_test(qxmppsessioniq)
add_simple_test(qxmppsocks)
add_simple_test(qxmppstanza)
add_simple_test(qxmppstarttlspacket)
add_simple_test(qxmppstreamfeatures)
add_simple_test(qxmppstunmessage)
add_simple_test(qxmppvcardiq)
add_simple_test(qxmppvcardmanager)
add_simple_test(qxmppversioniq)

if(WITH_GSTREAMER)
    add_simple_test(qxmppcallmanager)
endif()

if(BUILD_INTERNAL_TESTS)
    add_simple_test(qxmppsasl)
    add_simple_test(qxmppstreaminitiationiq)
endif()

add_subdirectory(qxmpptransfermanager)
add_subdirectory(qxmpputils)
add_subdirectory(qxmppuploadrequestmanager)

=== examples/example_9_vCard/CMakeLists.txt ===
find_package(Qt5 REQUIRED COMPONENTS Gui)

add_executable(9_vCard example_9_vCard.cpp)
target_link_libraries(9_vCard Qt5::Gui qxmpp)

=== tests/qxmppuploadrequestmanager/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_executable(tst_qxmppuploadrequestmanager tst_qxmppuploadrequestmanager.cpp tst_qxmppuploadrequestmanager.qrc)
add_test(tst_qxmppuploadrequestmanager tst_qxmppuploadrequestmanager)
target_link_libraries(tst_qxmppuploadrequestmanager Qt5::Test qxmpp)

=== debian/changelog ===
qxmpp (1.3.2-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.
  * Decrease debhelper-compat version to 12 (was 13).
  * Add -Wl,--as-needed flag to LDFLAGS in debian/rules.

 -- Boris Pek <tehnick@debian.org>  Sun, 17 Jan 2021 00:41:16 +0300

qxmpp (1.3.2-2) unstable; urgency=medium

  * Add dependency from libgstreamer1.0-dev to libqxmpp-dev package.

 -- Boris Pek <tehnick@debian.org>  Sun, 10 Jan 2021 01:24:09 +0300

qxmpp (1.3.2-1) unstable; urgency=medium

  * New upstream release.
  * Only bug fixes, no changes in ABI.

 -- Boris Pek <tehnick@debian.org>  Sun, 10 Jan 2021 00:28:28 +0300

qxmpp (1.3.1-2) unstable; urgency=medium

  * Move to unstable: no changes required.

 -- Boris Pek <tehnick@debian.org>  Wed, 30 Dec 2020 02:09:19 +0300

qxmpp (1.3.1-1) experimental; urgency=medium

  [ Aurélien COUDERC ]
  * Add salsa-ci.yml pipeline for GitLab CI/CD on Salsa.

  [ Boris Pek ]
  * New upstream release.
  * Update debian/control:
    - bump Standards-Version to 4.5.1 (was 4.5.0): no changes required
    - bump debhelper-compat version to 13 (was 12)
    - remove build dependencies from libopus-dev, libspeex-dev, libtheora-dev
      and libvpx-dev
    - add build dependency from libgstreamer1.0-dev
    - add extra dependencies from gstreamer1.0-plugins-base,
      gstreamer1.0-plugins-good and gstreamer1.0-plugins-ugly to binary package
      libqxmpp3
  * Update debian/rules:
    - update configuration options after switching library to gstreamer usage
    - remove DEB_LDFLAGS_MAINT_APPEND variable with -Wl,--as-needed flag
  * Bump debian/watch version to 4: no changes required.
  * Update debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Sat, 12 Dec 2020 03:57:50 +0300

qxmpp (1.2.0-1) experimental; urgency=medium

  * New upstream release.
  * Rename libqxmpp2 to libqxmpp3 after bumping of SOVERSION.
  * Update debian/control:
    - bump Standards-Version to 4.5.0 (was 4.4.1): no changes required
    - package libqxmpp3 replaces old libqxmpp2 package
  * Update debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Mon, 24 Feb 2020 20:45:25 +0300

qxmpp (1.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Delete all patches: already in upstream.
  * Bump Standards-Version to 4.4.1 (was 4.3.0): no changes required.
  * Rename libqxmpp1 to libqxmpp2 after bumping of SOVERSION.
  * Package libqxmpp2 now replaces libqxmpp0 and libqxmpp1 packages.
  * Update debian/copyright and debian/upstream/metadata.
  * Update debian/control:
    - add "Rules-Requires-Root: no"
    - replace build dependency from debhelper (>= 12~) to
      debhelper-compat (= 12)
  * Delete debian/compat.

 -- Boris Pek <tehnick@debian.org>  Thu, 21 Nov 2019 00:55:29 +0300

=== debian/control ===
Source: qxmpp
Section: libs
Priority: optional
Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>, Boris Pek <tehnick@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               doxygen,
               graphviz,
               libgstreamer1.0-dev,
               qtbase5-dev
Standards-Version: 4.5.1
Rules-Requires-Root: no
Homepage: https://github.com/qxmpp-project/qxmpp
Vcs-Git: https://salsa.debian.org/xmpp-team/qxmpp.git
Vcs-Browser: https://salsa.debian.org/xmpp-team/qxmpp

Package: libqxmpp3
Architecture: any
Replaces: libqxmpp0, libqxmpp1, libqxmpp2
Breaks: libqxmpp0, libqxmpp1, libqxmpp2
Depends: gstreamer1.0-plugins-base,
         gstreamer1.0-plugins-good,
         gstreamer1.0-plugins-ugly,
         ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: QXmpp library for XMPP client and server applications
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the shared library.

Package: libqxmpp-dev
Section: libdevel
Architecture: any
Depends: libgstreamer1.0-dev,
         libqxmpp3 (= ${binary:Version}),
         qtbase5-dev,
         ${misc:Depends}
Suggests: libqxmpp-doc
Multi-Arch: same
Description: Development files for the QXmpp library
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the development headers and libraries.

Package: libqxmpp-doc
Section: doc
Architecture: all
Depends: lynx | www-browser, ${misc:Depends}
Suggests: libqxmpp-dev
Description: Documentation for the QXmpp library
 QXmpp is a cross-platform C++ XMPP library built upon Qt. It strives to be
 as easy to use as possible.
 .
 This package contains the HTML documentation.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

CMAKEOPTS = -DBUILD_DOCUMENTATION=ON \
            -DBUILD_EXAMPLES=ON \
            -DBUILD_TESTS=OFF \
            -DWITH_GSTREAMER=ON

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKEOPTS)

override_dh_installdocs:
	dh_installdocs
	dh_doxygen -i

.PHONY: override_dh_auto_test-indep

## qxmpp 1.4.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,18 @@
 cmake_minimum_required(VERSION 3.3)
-project(qxmpp)
+project(qxmpp VERSION 1.4.0)
 
-set(VERSION_MAJOR 1)
-set(VERSION_MINOR 3)
-set(VERSION_PATCH 2)
 set(SO_VERSION 3)
-set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
-mark_as_advanced(VERSION_MAJOR VERSION_MINOR VERSION_PATCH VERSION_STRING)
 
-set(CMAKE_CXX_STANDARD 11)
+# C++ standard settings:
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/modules")
 
-find_package(Qt5 5.7.0 REQUIRED COMPONENTS Core Network Xml)
+find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core Network Xml)
+find_package(Qt${QT_VERSION_MAJOR} 5.7.0 REQUIRED COMPONENTS Core Network Xml)
+
 set(CMAKE_AUTOMOC ON)
 set(CMAKE_AUTORCC ON)
 
@@ -23,6 +24,13 @@
 option(BUILD_EXAMPLES "Build examples." ON)
 
 option(WITH_GSTREAMER "Build with GStreamer support for Jingle" OFF)
+
+add_definitions(
+    -DQT_DISABLE_DEPRECATED_BEFORE=0x050F00
+    -DQURL_NO_CAST_FROM_STRING
+    -DQT_NO_CAST_TO_ASCII
+    -DQT_NO_FOREACH
+)
 
 add_subdirectory(src)
 
@@ -49,7 +57,7 @@
 
 write_basic_package_version_file(
     ${CMAKE_CURRENT_BINARY_DIR}/QXmppConfigVersion.cmake
-    VERSION ${VERSION_STRING}
+    VERSION ${PROJECT_VERSION}
     COMPATIBILITY SameMajorVersion
 )

=== doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED)

if(NOT DOXYGEN_FOUND)
    message(FATAL_ERROR "Doxygen is needed to build the documentation.")
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
    ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    @ONLY
)

add_custom_target(
    doc ALL
    COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generate API documentation with Doxygen"
    VERBATIM
)

install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/html DESTINATION ${CMAKE_INSTALL_DOCDIR})

=== examples/CMakeLists.txt ===
macro(add_simple_example EXAMPLE_NAME)
    add_executable(${EXAMPLE_NAME} example_${EXAMPLE_NAME}/example_${EXAMPLE_NAME}.cpp)
    target_link_libraries(${EXAMPLE_NAME} qxmpp)
endmacro()

include_directories(${PROJECT_SOURCE_DIR}/src/base)
include_directories(${PROJECT_SOURCE_DIR}/src/client)
include_directories(${PROJECT_SOURCE_DIR}/src/server)
include_directories(${PROJECT_BINARY_DIR}/src/base)

add_simple_example(0_connected)
add_simple_example(1_echoClient)
add_simple_example(2_rosterHandling)
add_simple_example(3_transferHandling)
add_simple_example(7_archiveHandling)
add_simple_example(8_server)

add_subdirectory(example_5_rpcInterface)
add_subdirectory(example_6_rpcClient)
add_subdirectory(example_9_vCard)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 option(BUILD_SHARED "Build SHARED library" ON)
 
 add_definitions(-DQXMPP_BUILD)
-
-# disable Q_FOREACH()
-add_definitions(-DQT_NO_FOREACH)
 
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/base)
 include_directories(${CMAKE_CURRENT_SOURCE_DIR}/client)
@@ -41,6 +38,7 @@
     base/QXmppLogger.h
     base/QXmppMamIq.h
     base/QXmppMessage.h
+    base/QXmppMixInvitation.h
     base/QXmppMixIq.h
     base/QXmppMixItem.h
     base/QXmppMucIq.h
@@ -67,6 +65,7 @@
 
     # Client
     client/QXmppArchiveManager.h
+    client/QXmppAttentionManager.h
     client/QXmppBookmarkManager.h
     client/QXmppCarbonManager.h
     client/QXmppClient.h
@@ -122,6 +121,7 @@
     base/QXmppLogger.cpp
     base/QXmppMamIq.cpp
     base/QXmppMessage.cpp
+    base/QXmppMixInvitation.cpp
     base/QXmppMixIq.cpp
     base/QXmppMixItem.cpp
     base/QXmppMucIq.cpp
@@ -150,13 +150,14 @@
     base/QXmppVersionIq.cpp
 
     # Client
-    client/QXmppDiscoveryManager.cpp
     client/QXmppArchiveManager.cpp
+    client/QXmppAttentionManager.cpp
     client/QXmppBookmarkManager.cpp
     client/QXmppCarbonManager.cpp
     client/QXmppClient.cpp
     client/QXmppClientExtension.cpp
     client/QXmppConfiguration.cpp
+    client/QXmppDiscoveryManager.cpp
     client/QXmppEntityTimeManager.cpp
     client/QXmppInternalClientExtension.cpp
     client/QXmppInvokable.cpp
@@ -212,7 +213,7 @@
 endif()
 
 set_target_properties(qxmpp PROPERTIES
-    VERSION ${VERSION_STRING}
+    VERSION ${PROJECT_VERSION}
     SOVERSION ${SO_VERSION}
     EXPORT_NAME QXmpp
 )
@@ -231,14 +232,14 @@
 
 target_link_libraries(qxmpp
     PUBLIC
-    Qt5::Core
-    Qt5::Network
-    Qt5::Xml
+    Qt${QT_VERSION_MAJOR}::Core
+    Qt${QT_VERSION_MAJOR}::Network
+    Qt${QT_VERSION_MAJOR}::Xml
 )
 
 if(WITH_GSTREAMER)
     target_link_libraries(qxmpp
-        PUBLIC
+        PRIVATE
         ${GLIB2_LIBRARIES}
         ${GOBJECT_LIBRARIES}
         ${GSTREAMER_LIBRARY}

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,11 @@
 include_directories(.)
 
-find_package(Qt5 REQUIRED COMPONENTS Test)
+find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Test)
 
 macro(add_simple_test TEST_NAME)
     add_executable(tst_${TEST_NAME} ${TEST_NAME}/tst_${TEST_NAME}.cpp)
     add_test(tst_${TEST_NAME} tst_${TEST_NAME})
-    target_link_libraries(tst_${TEST_NAME} Qt5::Test qxmpp)
+    target_link_libraries(tst_${TEST_NAME} Qt${QT_VERSION_MAJOR}::Test qxmpp)
 endmacro()
 
 include_directories(${PROJECT_SOURCE_DIR}/src/base)
@@ -15,6 +15,7 @@
 include_directories(${CMAKE_CURRENT_BINARY_DIR})
 
 add_simple_test(qxmpparchiveiq)
+add_simple_test(qxmppattentionmanager)
 add_simple_test(qxmppbindiq)
 add_simple_test(qxmppbitsofbinarycontentid)
 add_simple_test(qxmppbitsofbinaryiq)
@@ -28,11 +29,13 @@
 add_simple_test(qxmppiq)
 add_simple_test(qxmppjingleiq)
 add_simple_test(qxmppmammanager)
+add_simple_test(qxmppmixinvitation)
 add_simple_test(qxmppmixitem)
 add_simple_test(qxmppmessage)
 add_simple_test(qxmppmessagereceiptmanager)
 add_simple_test(qxmppmixiq)
 add_simple_test(qxmppnonsaslauthiq)
+add_simple_test(qxmppoutgoingclient)
 add_simple_test(qxmpppushenableiq)
 add_simple_test(qxmpppresence)
 add_simple_test(qxmpppubsubiq)
@@ -47,6 +50,7 @@
 add_simple_test(qxmppsocks)
 add_simple_test(qxmppstanza)
 add_simple_test(qxmppstarttlspacket)
+add_simple_test(qxmppstream)
 add_simple_test(qxmppstreamfeatures)
 add_simple_test(qxmppstunmessage)
 add_simple_test(qxmppvcardiq)
@@ -65,4 +69,3 @@
 add_subdirectory(qxmpptransfermanager)
 add_subdirectory(qxmpputils)
 add_subdirectory(qxmppuploadrequestmanager)
-

=== examples/example_5_rpcInterface/CMakeLists.txt ===
add_executable(5_rpcInterface main.cpp remoteinterface.cpp)
target_link_libraries(5_rpcInterface qxmpp)

=== examples/example_6_rpcClient/CMakeLists.txt ===
add_executable(6_rpcClient main.cpp rpcClient.cpp)
target_link_libraries(6_rpcClient qxmpp)

=== examples/example_9_vCard/CMakeLists.txt ===
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS Gui)

add_executable(9_vCard example_9_vCard.cpp)
target_link_libraries(9_vCard Qt${QT_VERSION_MAJOR}::Gui qxmpp)

=== tests/qxmpptransfermanager/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_executable(tst_qxmpptransfermanager tst_qxmpptransfermanager.cpp tst_qxmpptransfermanager.qrc)
add_test(tst_qxmpptransfermanager tst_qxmpptransfermanager)
target_link_libraries(tst_qxmpptransfermanager Qt${QT_VERSION_MAJOR}::Test qxmpp)

=== tests/qxmppuploadrequestmanager/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_executable(tst_qxmppuploadrequestmanager tst_qxmppuploadrequestmanager.cpp tst_qxmppuploadrequestmanager.qrc)
add_test(tst_qxmppuploadrequestmanager tst_qxmppuploadrequestmanager)
target_link_libraries(tst_qxmppuploadrequestmanager Qt${QT_VERSION_MAJOR}::Test qxmpp)

=== tests/qxmpputils/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_executable(tst_qxmpputils tst_qxmpputils.cpp tst_qxmpputils.qrc)
add_test(tst_qxmpputils tst_qxmpputils)
target_link_libraries(tst_qxmpputils Qt${QT_VERSION_MAJOR}::Test qxmpp)

=== debian/changelog ===
qxmpp (1.4.0-2) unstable; urgency=medium

  * Move to unstable: no changes required.
  * Update debian/watch.

 -- Boris Pek <tehnick@debian.org>  Thu, 26 Aug 2021 08:01:28 +0300

qxmpp (1.4.0-1) experimental; urgency=medium

  * New upstream release.
  * Update years in debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Mon, 15 Mar 2021 21:56:17 +0300

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian XMPP Maintainers <pkg-xmpp-devel@lists.alioth.debian.org>
 Uploaders: Jeremy Lainé <jeremy.laine@m4x.org>, Boris Pek <tehnick@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                doxygen,
                graphviz,
                libgstreamer1.0-dev,

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,5 @@
 #!/usr/bin/make -f
 
-export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 CMAKEOPTS = -DBUILD_DOCUMENTATION=ON \
